TIFFDescriptor (Media Authoring with Java API)
Date: 2016-02-05

tv.amwa.maj.model

## Interface TIFFDescriptor

- All Superinterfaces:
    AAFFileDescriptor, EssenceDescriptor, InterchangeObject, MediaEntity, MetadataObject
  All Known Implementing Classes:
    TIFFDescriptorImpl

      public interface TIFFDescriptor
      extends AAFFileDescriptor

  Specifies the description of a file of video essence formatted according to the Tagged Image File Format (TIFF) specification.

  For more information, see the description of TIFF on Wikipedia.

  See Also:
    `SourcePackage.getEssenceDescriptor()`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `LEADINGLINES_DEFAULT` Default value for the leading lines property, which is 0.
    `static int` | `TRAILINGLINES_DEFAULT` Default value for the trailing lines property, which is 0.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `TIFFDescriptor` | `clone()` Create a cloned copy of this TIFF descriptor.
    `boolean` | `getIsContiguous()` Returns `true` if essence data is stored in contiguous bytes for the TIFF data described by this TIFF descriptor; otherwise `false.`
    `boolean` | `getIsUniform()` Returns `true` if the TIFF data described by this TIFF descriptor has the same number of rows per strip throughout; otherwise `false`.
    `int` | `getJPEGTableID()` Returns the JPEG table code property of this TIFF descriptor, which specifies the registered JPEG table code.
    `int` | `getLeadingLines()` Returns the number of leading lines of the TIFF descriptor, which specifies the number of leading lines to be thrown away when viewing the TIFF data.
    `int` | `getSummaryBufferSize()` Deprecated. Use `getTIFFSummary()``.length` instead.
    `byte[]` | `getTIFFSummary()` Returns the copy of the TIFF IFD file information of this TIFF descriptor, without the sample data.
    `int` | `getTrailingLines()` Returns the number of trailing lines of this TIFF descriptor, which specifies the number of trailing lines to be thrown away when viewing the TIFF data.
    `void` | `setIsContiguous(boolean isContiguous)` Sets whether essence data is stored in contiguous bytes for the TIFF data described by this TIFF descriptor.
    `void` | `setIsUniform(boolean isUniform)` Sets whether the TIFF data described by this TIFF descriptor has the same number of rows per strip throughout.
    `void` | `setJPEGTableID(Integer jpegTableId)` Sets the JPEG table code property of this TIFF descriptor, which specifies the registered JPEG table code.
    `void` | `setLeadingLines(Integer leadingLines)` Sets the number of leading lines of this TIFF descriptor, which specifies the number of leading lines to be thrown away when viewing the TIFF data.
    `void` | `setTIFFSummary(byte[] tiffSummary)` Sets the copy of the TIFF IFD file information of this TIFF descriptor, without the sample data.
    `void` | `setTrailingLines(Integer trailingLines)` Sets the number of trailing lines of this TIFF descriptor, which specifies the number of trailing lines to be thrown away when viewing the TIFF data.

    - ### Methods inherited from interface tv.amwa.maj.model.AAFFileDescriptor

      `getCodec, getContainerFormat, getEssenceLength, getLinkedTrackID, getSampleRate, setCodec, setContainerFormat, setEssenceLength, setLinkedTrackID, setSampleRate`

    - ### Methods inherited from interface tv.amwa.maj.model.EssenceDescriptor

      `appendLocator, appendSubDescriptor, clearLocators, countLocators, countSubDescriptors, getLocatorAt, getLocators, getSubDescriptorAt, getSubDescriptors, insertLocatorAt, insertSubDescriptorAt, prependLocator, prependSubDescriptor, removeLocatorAt, removeSubDescriptorAt`

    - ### Methods inherited from interface tv.amwa.maj.model.InterchangeObject

      `addApplicationPlugin, clearApplicationPlugins, containsApplicationPlugin, containsApplicationPlugin, countApplicationPlugins, deepEquals, disableGenerationTracking, enableGenerationTracking, equals, getApplicationPlugins, getGeneration, getLinkedGenerationID, getObjectClass, isGenerationTracked, removeApplicationPlugin, removeApplicationPlugin, setLinkedGenerationID, setObjectClass, toString`

    - ### Methods inherited from interface tv.amwa.maj.industry.MediaEntity

      `getPersistentID, setPersistentIndex`

- - ### Field Detail

    - #### LEADINGLINES_DEFAULT

          static final int LEADINGLINES_DEFAULT

      Default value for the leading lines property, which is 0.

      See Also:
        `getLeadingLines()`, `setLeadingLines(Integer)`, Constant Field Values

    - #### TRAILINGLINES_DEFAULT

          static final int TRAILINGLINES_DEFAULT

      Default value for the trailing lines property, which is 0.

      See Also:
        `getTrailingLines()`, `setTrailingLines(Integer)`, Constant Field Values

  - ### Method Detail

    - #### setIsUniform

          void setIsUniform(@Bool
                            boolean isUniform)

      Sets whether the TIFF data described by this TIFF descriptor has the same number of rows per strip throughout. Set to `true` if it does; otherwise `false`.

      Parameters:
        `isUniform` - Does the TIFF data described by this TIFF descriptor have the same number of rows per strip throughout?

    - #### getIsUniform

          @Bool
          boolean getIsUniform()

      Returns `true` if the TIFF data described by this TIFF descriptor has the same number of rows per strip throughout; otherwise `false`.

      Returns:
        Does the TIFF data represented by the TIFF descriptor have the same number of rows per strip throughout?

    - #### setIsContiguous

          void setIsContiguous(@Bool
                               boolean isContiguous)

      Sets whether essence data is stored in contiguous bytes for the TIFF data described by this TIFF descriptor. Set to `true` if the data is contiguous; otherwise `false`.

      Parameters:
        `isContiguous` - Is the TIFF data represented by the TIFF descriptor stored in contiguous bytes?

    - #### getIsContiguous

          @Bool
          boolean getIsContiguous()

      Returns `true` if essence data is stored in contiguous bytes for the TIFF data described by this TIFF descriptor; otherwise `false.`

      Returns:
        Is the TIFF data represented by the TIFF descriptor stored in contiguous bytes?

    - #### setLeadingLines

          void setLeadingLines(@Int32
                               Integer leadingLines)

      Sets the number of leading lines of this TIFF descriptor, which specifies the number of leading lines to be thrown away when viewing the TIFF data.

      The optional property has a default value of 0. Set this optional property to `null` to omit it.

      Parameters:
        `leadingLines` - Number of leading lines of this TIFF descriptor.
      See Also:
        `LEADINGLINES_DEFAULT`, `setTrailingLines(Integer)`

    - #### getLeadingLines

          @Int32
          int getLeadingLines()

      Returns the number of leading lines of the TIFF descriptor, which specifies the number of leading lines to be thrown away when viewing the TIFF data.

      If this optional property is omitted, its default value of 0 will be returned.

      Returns:
        Number of leading lines of the TIFF descriptor.
      See Also:
        `LEADINGLINES_DEFAULT`, `getTrailingLines()`

    - #### setTrailingLines

          void setTrailingLines(@Int32
                                Integer trailingLines)

      Sets the number of trailing lines of this TIFF descriptor, which specifies the number of trailing lines to be thrown away when viewing the TIFF data.

      This optional property has a default value of 0. Set this optional property to `null` to omit it.

      Parameters:
        `trailingLines` - Trailing lines of this TIFF descriptor.
      See Also:
        `TRAILINGLINES_DEFAULT`, `setLeadingLines(Integer)`

    - #### getTrailingLines

          @Int32
          int getTrailingLines()

      Returns the number of trailing lines of this TIFF descriptor, which specifies the number of trailing lines to be thrown away when viewing the TIFF data.

      If this optional property is omitted, its default value of 0 will be returned.

      Returns:
        Trailing lines of this TIFF descriptor.
      See Also:
        `TRAILINGLINES_DEFAULT`, `getTrailingLines()`

    - #### setJPEGTableID

          void setJPEGTableID(@JPEGTableIDType
                              Integer jpegTableId)

      Sets the JPEG table code property of this TIFF descriptor, which specifies the registered JPEG table code. Set this optional property to `null` to omit it and indicate that the described image data uses a table that is not registered.

      Parameters:
        `jpegTableId` - JPEG table code property of tis TIFF descriptor.

    - #### getJPEGTableID

          @JPEGTableIDType
          int getJPEGTableID()
                                       throws PropertyNotPresentException

      Returns the JPEG table code property of this TIFF descriptor, which specifies the registered JPEG table code. This is an optional property that, when omitted, indicate that the described image data uses a table that is not registered.

      Returns:
        JPEG table code property of this TIFF descriptor.
      Throws:
        `PropertyNotPresentException` - The optional JPEG table id property is not present in this TIFF descriptor.

    - #### getTIFFSummary

          @DataValue
          byte[] getTIFFSummary()

      Returns the copy of the TIFF IFD file information of this TIFF descriptor, without the sample data.

      Returns:
        Copy of the TIFF IFD file information of the TIFF descriptor.

    - #### getSummaryBufferSize

          @Deprecated
           @UInt32
          int getSummaryBufferSize()

      Deprecated. Use `getTIFFSummary()``.length` instead.

      Returns the size of the buffer required by the `getTIFFSummary()` method.

      Returns:
        Size of the buffer required by the `getTIFFSummary()` method.

    - #### setTIFFSummary

          void setTIFFSummary(@DataValue
                              byte[] tiffSummary)
                       throws NullPointerException

      Sets the copy of the TIFF IFD file information of this TIFF descriptor, without the sample data.

      Parameters:
        `tiffSummary` - Sets the TIFF IFD file information of this TIFF descriptor.
      Throws:
        `NullPointerException` - The given TIFF IFD data is `null`.

    - #### clone

          TIFFDescriptor clone()

      Create a cloned copy of this TIFF descriptor.

      Specified by:
        `clone` in interface `AAFFileDescriptor`
      Specified by:
        `clone` in interface `EssenceDescriptor`
      Specified by:
        `clone` in interface `InterchangeObject`
      Specified by:
        `clone` in interface `MediaEntity`
      Returns:
        Cloned copy of this TIFF descriptor.

(c)2007-2016 Richard Cartwright, all rights reserved. Licensed under Apache 2 license and subject to the AMWA IPR policy.